-- DASHBOARDS
UPDATE PERMISSIONS
SET NAME = 'reporting:dashboards:read-hidden'
WHERE NAME = 'VIEW_HIDDEN_DASHBOARDS';

UPDATE PERMISSIONS
SET NAME = 'reporting:dashboards:update'
WHERE NAME = 'MODIFY_DASHBOARDS';

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:dashboards:delete')
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
SELECT G.ID AS GROUP_ID, (SELECT ID AS PERMISSION_ID FROM PERMISSIONS WHERE NAME = 'reporting:dashboards:delete') AS PERMISSION_ID
FROM GROUPS G
JOIN GROUP_PERMISSIONS GP
	ON G.ID=GP.GROUP_ID
JOIN PERMISSIONS P
	ON P.ID=GP.PERMISSION_ID
WHERE P.NAME='reporting:dashboards:update'
ON CONFLICT DO NOTHING;

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:dashboards:*')
ON CONFLICT DO NOTHING;

-- WIDGETS
UPDATE PERMISSIONS
SET NAME = 'reporting:widgets:update'
WHERE NAME = 'MODIFY_WIDGETS';

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:widgets:delete')
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
SELECT G.ID AS GROUP_ID, (SELECT ID AS PERMISSION_ID FROM PERMISSIONS WHERE NAME = 'reporting:widgets:delete') AS PERMISSION_ID
FROM GROUPS G
JOIN GROUP_PERMISSIONS gp
	ON G.ID=GP.GROUP_ID
JOIN PERMISSIONS P
	ON P.ID=GP.PERMISSION_ID
WHERE P.NAME='reporting:widgets:update'
ON CONFLICT DO NOTHING;

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:widgets:*')
ON CONFLICT DO NOTHING;

-- TEST RUNS
UPDATE PERMISSIONS
SET NAME = 'reporting:test-runs:update'
WHERE NAME = 'MODIFY_TEST_RUNS';

UPDATE PERMISSIONS
SET NAME = 'reporting:test-runs:read'
WHERE NAME = 'TEST_RUNS_CI';

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
SELECT G.ID AS GROUP_ID, (SELECT ID AS PERMISSION_ID FROM PERMISSIONS WHERE NAME = 'reporting:test-runs:read') AS PERMISSION_ID
FROM GROUPS G
JOIN GROUP_PERMISSIONS gp
	ON G.ID=GP.GROUP_ID
JOIN PERMISSIONS P
	ON P.ID=GP.PERMISSION_ID
WHERE P.NAME='reporting:test-runs:update'
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
SELECT G.ID AS GROUP_ID, (SELECT ID AS PERMISSION_ID FROM PERMISSIONS WHERE NAME = 'reporting:test-runs:update') AS PERMISSION_ID
FROM GROUPS G
JOIN GROUP_PERMISSIONS gp
	ON G.ID=GP.GROUP_ID
JOIN PERMISSIONS P
	ON P.ID=GP.PERMISSION_ID
WHERE P.NAME='reporting:test-runs:read'
ON CONFLICT DO NOTHING;

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:test-runs:delete')
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
SELECT G.ID AS GROUP_ID, (SELECT ID AS PERMISSION_ID FROM PERMISSIONS WHERE NAME = 'reporting:test-runs:delete') AS PERMISSION_ID
FROM GROUPS G
JOIN GROUP_PERMISSIONS gp
	ON G.ID=GP.GROUP_ID
JOIN PERMISSIONS P
	ON P.ID=GP.PERMISSION_ID
WHERE P.NAME='reporting:test-runs:update'
ON CONFLICT DO NOTHING;

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:test-runs:*')
ON CONFLICT DO NOTHING;

-- TESTS
UPDATE PERMISSIONS
SET NAME = 'reporting:tests:update'
WHERE NAME = 'MODIFY_TESTS';

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:tests:*')
ON CONFLICT DO NOTHING;

-- TEST SESSION TOKEN
UPDATE PERMISSIONS
SET NAME = 'reporting:test-sessions:token:refresh'
WHERE NAME = 'REFRESH_TOKEN';

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:test-sessions:token:*')
ON CONFLICT DO NOTHING;

-- USERS
UPDATE PERMISSIONS
SET NAME = 'iam:users:update'
WHERE NAME = 'MODIFY_USERS';

UPDATE PERMISSIONS
SET NAME = 'iam:users:read'
WHERE NAME = 'VIEW_USERS';

INSERT INTO PERMISSIONS (NAME)
VALUES ('iam:users:*')
ON CONFLICT DO NOTHING;

-- USERS INVITATIONS
UPDATE PERMISSIONS
SET NAME = 'iam:invitations:update'
WHERE NAME = 'INVITE_USERS';

UPDATE PERMISSIONS
SET NAME = 'iam:invitations:delete'
WHERE NAME = 'MODIFY_INVITATIONS';

INSERT INTO PERMISSIONS (NAME)
VALUES ('iam:invitations:read')
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
SELECT G.ID AS GROUP_ID, (SELECT ID AS PERMISSION_ID FROM PERMISSIONS WHERE NAME = 'iam:invitations:read') AS PERMISSION_ID
FROM GROUPS G
JOIN GROUP_PERMISSIONS gp
	ON G.ID=GP.GROUP_ID
JOIN PERMISSIONS P
	ON P.ID=GP.PERMISSION_ID
WHERE P.NAME='iam:invitations:update'
ON CONFLICT DO NOTHING;

INSERT INTO PERMISSIONS (NAME)
VALUES ('iam:invitations:*')
ON CONFLICT DO NOTHING;

-- USER GROUPS
UPDATE PERMISSIONS
SET NAME = 'iam:groups:update'
WHERE NAME = 'MODIFY_USER_GROUPS';

INSERT INTO PERMISSIONS (NAME)
VALUES ('iam:groups:read')
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
SELECT G.ID AS GROUP_ID, (SELECT ID AS PERMISSION_ID FROM PERMISSIONS WHERE NAME = 'iam:groups:read') AS PERMISSION_ID
FROM GROUPS G
JOIN GROUP_PERMISSIONS gp
	ON G.ID=GP.GROUP_ID
JOIN PERMISSIONS P
	ON P.ID=GP.PERMISSION_ID
WHERE P.NAME='iam:groups:update'
ON CONFLICT DO NOTHING;

INSERT INTO PERMISSIONS (NAME)
VALUES ('iam:groups:delete')
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
SELECT G.ID AS GROUP_ID, (SELECT ID AS PERMISSION_ID FROM PERMISSIONS WHERE NAME = 'iam:groups:delete') AS PERMISSION_ID
FROM GROUPS G
JOIN GROUP_PERMISSIONS gp
	ON G.ID=GP.GROUP_ID
JOIN PERMISSIONS P
	ON P.ID=GP.PERMISSION_ID
WHERE P.NAME='iam:groups:update'
ON CONFLICT DO NOTHING;

INSERT INTO PERMISSIONS (NAME)
VALUES ('iam:groups:*')
ON CONFLICT DO NOTHING;

-- PROJECTS
UPDATE PERMISSIONS
SET NAME = 'reporting:projects:update'
WHERE NAME = 'MODIFY_PROJECTS';

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:projects:delete')
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
SELECT G.ID AS GROUP_ID, (SELECT ID AS PERMISSION_ID FROM PERMISSIONS WHERE NAME = 'reporting:projects:delete') AS PERMISSION_ID
FROM GROUPS G
JOIN GROUP_PERMISSIONS gp
	ON G.ID=GP.GROUP_ID
JOIN PERMISSIONS P
	ON P.ID=GP.PERMISSION_ID
WHERE P.NAME='reporting:projects:update'
ON CONFLICT DO NOTHING;

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:projects:*')
ON CONFLICT DO NOTHING;

-- INTEGRATIONS
UPDATE PERMISSIONS
SET NAME = 'reporting:integrations:update'
WHERE NAME = 'MODIFY_INTEGRATIONS';

UPDATE PERMISSIONS
SET NAME = 'reporting:integrations:read'
WHERE NAME = 'VIEW_INTEGRATIONS';

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:integrations:*')
ON CONFLICT DO NOTHING;

-- LAUNCHERS
UPDATE PERMISSIONS
SET NAME = 'reporting:launchers:update'
WHERE NAME = 'MODIFY_LAUNCHERS';

UPDATE PERMISSIONS
SET NAME = 'reporting:launchers:read'
WHERE NAME = 'VIEW_LAUNCHERS';

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:launchers:delete')
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
SELECT G.ID AS GROUP_ID, (SELECT ID AS PERMISSION_ID FROM PERMISSIONS WHERE NAME = 'reporting:launchers:delete') AS PERMISSION_ID
FROM GROUPS G
JOIN GROUP_PERMISSIONS gp
	ON G.ID=GP.GROUP_ID
JOIN PERMISSIONS P
	ON P.ID=GP.PERMISSION_ID
WHERE P.NAME='reporting:launchers:update'
ON CONFLICT DO NOTHING;

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:launchers:*')
ON CONFLICT DO NOTHING;

-- SETTINGS
UPDATE PERMISSIONS
SET NAME = 'reporting:settings:update'
WHERE NAME = 'UPDATE_SETTINGS';

INSERT INTO PERMISSIONS (NAME)
VALUES ('reporting:settings:*')
ON CONFLICT DO NOTHING;
